diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index c5f6593..1789f0b 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -3286,9 +3305,9 @@ initial_cost_hashjoin(PlannerInfo *root, JoinCostWorkspace *workspace,
 	 * should charge the extra eval costs of the left or right side, as
 	 * appropriate, here.  This seems more work than it's worth at the moment.
 	 */
-	startup_cost += (cpu_operator_cost * num_hashclauses + cpu_tuple_cost)
-		* inner_path_rows;
-	run_cost += cpu_operator_cost * num_hashclauses * outer_path_rows;
+	cost_add_member_mul(&startup_cost, cpu_operator_cost, num_hashclauses * inner_path_rows);
+	cost_add_member_mul(&startup_cost, cpu_tuple_cost, inner_path_rows);
+	cost_add_member_mul(&run_cost, cpu_operator_cost, num_hashclauses * outer_path_rows);
 
 	/*
 	 * If this is a parallel hash build, then the value we have for
@@ -3333,15 +3352,15 @@ initial_cost_hashjoin(PlannerInfo *root, JoinCostWorkspace *workspace,
 		double		innerpages = page_size(inner_path_rows,
 										   inner_path->pathtarget->width);
 
-		startup_cost += seq_page_cost * innerpages;
-		run_cost += seq_page_cost * (innerpages + 2 * outerpages);
+		cost_add_member_mul(&startup_cost, seq_page_cost, innerpages);
+		cost_add_member_mul(&run_cost, seq_page_cost, (innerpages + 2 * outerpages));
 	}
 
 	/* CPU costs left for later */
 
 	/* Public result fields */
 	workspace->startup_cost = startup_cost;
-	workspace->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&workspace->total_cost, &startup_cost, &run_cost);
 	/* Save private data for final_cost_hashjoin */
 	workspace->run_cost = run_cost;
 	workspace->numbuckets = numbuckets;
@@ -3405,7 +3424,7 @@ final_cost_hashjoin(PlannerInfo *root, HashPath *path,
 	 * disabled, which doesn't seem like the way to bet.
 	 */
 	if (!enable_hashjoin)
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 
 	/* mark the path with estimated # of batches */
 	path->num_batches = numbatches;
@@ -3503,7 +3522,7 @@ final_cost_hashjoin(PlannerInfo *root, HashPath *path,
 	if (relation_byte_size(clamp_row_est(inner_path_rows * innermcvfreq),
 						   inner_path->pathtarget->width) >
 		(work_mem * 1024L))
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 
 	/*
 	 * Compute cost of the hashquals and qpquals (other restriction clauses)
@@ -3511,8 +3530,8 @@ final_cost_hashjoin(PlannerInfo *root, HashPath *path,
 	 */
 	cost_qual_eval(&hash_qual_cost, hashclauses, root);
 	cost_qual_eval(&qp_qual_cost, path->jpath.joinrestrictinfo, root);
-	qp_qual_cost.startup -= hash_qual_cost.startup;
-	qp_qual_cost.per_tuple -= hash_qual_cost.per_tuple;
+	cost_sub(&qp_qual_cost.startup, &hash_qual_cost.startup);
+	cost_sub(&qp_qual_cost.per_tuple, &hash_qual_cost.per_tuple);
 
 	/* CPU costs */
 
@@ -3538,9 +3557,9 @@ final_cost_hashjoin(PlannerInfo *root, HashPath *path,
 		outer_matched_rows = rint(outer_path_rows * extra->semifactors.outer_match_frac);
 		inner_scan_frac = 2.0 / (extra->semifactors.match_count + 1.0);
 
-		startup_cost += hash_qual_cost.startup;
-		run_cost += hash_qual_cost.per_tuple * outer_matched_rows *
-			clamp_row_est(inner_path_rows * innerbucketsize * inner_scan_frac) * 0.5;
+		cost_add(&startup_cost, &hash_qual_cost.startup);
+		cost_add_mul(&run_cost, &hash_qual_cost.per_tuple, outer_matched_rows *
+			clamp_row_est(inner_path_rows * innerbucketsize * inner_scan_frac) * 0.5);
 
 		/*
 		 * For unmatched outer-rel rows, the picture is quite a lot different.
@@ -3555,9 +3574,9 @@ final_cost_hashjoin(PlannerInfo *root, HashPath *path,
 		 * effective cost per bucket entry is one-tenth what it is for
 		 * matchable tuples.
 		 */
-		run_cost += hash_qual_cost.per_tuple *
+		cost_add_mul(&run_cost, &hash_qual_cost.per_tuple,
 			(outer_path_rows - outer_matched_rows) *
-			clamp_row_est(inner_path_rows / virtualbuckets) * 0.05;
+			clamp_row_est(inner_path_rows / virtualbuckets) * 0.05);
 
 		/* Get # of tuples that will pass the basic join */
 		if (path->jpath.jointype == JOIN_ANTI)
@@ -3577,9 +3596,9 @@ final_cost_hashjoin(PlannerInfo *root, HashPath *path,
 		 * exactly.  For lack of a better idea, halve the cost estimate to
 		 * allow for that.
 		 */
-		startup_cost += hash_qual_cost.startup;
-		run_cost += hash_qual_cost.per_tuple * outer_path_rows *
-			clamp_row_est(inner_path_rows * innerbucketsize) * 0.5;
+		cost_add(&startup_cost, &hash_qual_cost.startup);
+		cost_add_mul(&run_cost, &hash_qual_cost.per_tuple, outer_path_rows *
+			clamp_row_est(inner_path_rows * innerbucketsize) * 0.5);
 
 		/*
 		 * Get approx # tuples passing the hashquals.  We use
@@ -3595,16 +3614,17 @@ final_cost_hashjoin(PlannerInfo *root, HashPath *path,
 	 * clauses that are to be applied at the join.  (This is pessimistic since
 	 * not all of the quals may get evaluated at each tuple.)
 	 */
-	startup_cost += qp_qual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qp_qual_cost.per_tuple;
-	run_cost += cpu_per_tuple * hashjointuples;
+	cost_add(&startup_cost, &qp_qual_cost.startup);
+	cpu_per_tuple = qp_qual_cost.per_tuple;
+	cost_add_member(&cpu_per_tuple, cpu_tuple_cost);
+	cost_add_mul(&run_cost, &cpu_per_tuple, hashjointuples);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->jpath.path.pathtarget->cost.startup;
-	run_cost += path->jpath.path.pathtarget->cost.per_tuple * path->jpath.path.rows;
+	cost_add(&startup_cost, &path->jpath.path.pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->jpath.path.pathtarget->cost.per_tuple, path->jpath.path.rows);
 
 	path->jpath.path.startup_cost = startup_cost;
-	path->jpath.path.total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->jpath.path.total_cost, &startup_cost, &run_cost);
 }
 
 
@@ -3633,8 +3653,8 @@ cost_subplan(PlannerInfo *root, SubPlan *subplan, Plan *plan)
 		 * cpu_operator_cost per tuple for the work of loading the hashtable,
 		 * too.
 		 */
-		sp_cost.startup += plan->total_cost +
-			cpu_operator_cost * plan->plan_rows;
+		cost_add(&sp_cost.startup, &plan->total_cost);
+		cost_add_member_mul(&sp_cost.startup, cpu_operator_cost, plan->plan_rows);
 
 		/*
 		 * The per-tuple costs include the cost of evaluating the lefthand
@@ -3654,25 +3674,26 @@ cost_subplan(PlannerInfo *root, SubPlan *subplan, Plan *plan)
 		 * tuple_fraction estimates used by make_subplan() in
 		 * plan/subselect.c.
 		 */
-		Cost		plan_run_cost = plan->total_cost - plan->startup_cost;
+		Cost		plan_run_cost;
+		cost_set_diff(&plan_run_cost, &plan->total_cost, &plan->startup_cost);
 
 		if (subplan->subLinkType == EXISTS_SUBLINK)
 		{
 			/* we only need to fetch 1 tuple; clamp to avoid zero divide */
-			sp_cost.per_tuple += plan_run_cost / clamp_row_est(plan->plan_rows);
+			cost_add_mul(&sp_cost.per_tuple, &plan_run_cost, clamp_row_est(plan->plan_rows));
 		}
 		else if (subplan->subLinkType == ALL_SUBLINK ||
 				 subplan->subLinkType == ANY_SUBLINK)
 		{
 			/* assume we need 50% of the tuples */
-			sp_cost.per_tuple += 0.50 * plan_run_cost;
+			cost_add_mul(&sp_cost.per_tuple, &plan_run_cost, 0.50);
 			/* also charge a cpu_operator_cost per row examined */
-			sp_cost.per_tuple += 0.50 * plan->plan_rows * cpu_operator_cost;
+			cost_add_member_mul(&sp_cost.per_tuple, cpu_operator_cost, 0.50 * plan->plan_rows);
 		}
 		else
 		{
 			/* assume we need all tuples */
-			sp_cost.per_tuple += plan_run_cost;
+			cost_add(&sp_cost.per_tuple, &plan_run_cost);
 		}
 
 		/*
@@ -3684,9 +3705,9 @@ cost_subplan(PlannerInfo *root, SubPlan *subplan, Plan *plan)
 		 */
 		if (subplan->parParam == NIL &&
 			ExecMaterializesOutput(nodeTag(plan)))
-			sp_cost.startup += plan->startup_cost;
+			cost_add(&sp_cost.startup, &plan->startup_cost);
 		else
-			sp_cost.per_tuple += plan->startup_cost;
+			cost_add(&sp_cost.per_tuple, &plan->startup_cost);
 	}
 
 	subplan->startup_cost = sp_cost.startup;
@@ -3724,8 +3745,8 @@ cost_rescan(PlannerInfo *root, Path *path,
 			 * and isn't paid over again on rescans. However, all run costs
 			 * will be paid over again.
 			 */
-			*rescan_startup_cost = 0;
-			*rescan_total_cost = path->total_cost - path->startup_cost;
+			cost_zero(rescan_startup_cost);
+			cost_set_diff(rescan_total_cost, &path->total_cost, &path->startup_cost);
 			break;
 		case T_HashJoin:
 
@@ -3736,8 +3757,8 @@ cost_rescan(PlannerInfo *root, Path *path,
 			if (((HashPath *) path)->num_batches == 1)
 			{
 				/* Startup cost is exactly the cost of hash table building */
-				*rescan_startup_cost = 0;
-				*rescan_total_cost = path->total_cost - path->startup_cost;
+				cost_zero(rescan_startup_cost);
+				cost_set_diff(rescan_total_cost, &path->total_cost, &path->startup_cost);
 			}
 			else
 			{
@@ -3755,19 +3776,20 @@ cost_rescan(PlannerInfo *root, Path *path,
 				 * cpu_tuple_cost per tuple, unless the result is large enough
 				 * to spill to disk.
 				 */
-				Cost		run_cost = cpu_tuple_cost * path->rows;
+				Cost		run_cost;
 				double		nbytes = relation_byte_size(path->rows,
 														path->pathtarget->width);
 				long		work_mem_bytes = work_mem * 1024L;
 
+				cost_set_member_mul(&run_cost, cpu_tuple_cost, path->rows);
 				if (nbytes > work_mem_bytes)
 				{
 					/* It will spill, so account for re-read cost */
 					double		npages = ceil(nbytes / BLCKSZ);
 
-					run_cost += seq_page_cost * npages;
+					cost_add_member_mul(&run_cost, seq_page_cost, npages);
 				}
-				*rescan_startup_cost = 0;
+				cost_zero(rescan_startup_cost);
 				*rescan_total_cost = run_cost;
 			}
 			break;
@@ -3782,19 +3804,20 @@ cost_rescan(PlannerInfo *root, Path *path,
 				 * the run_cost charge in cost_sort, and also see comments in
 				 * cost_material before you change it.)
 				 */
-				Cost		run_cost = cpu_operator_cost * path->rows;
+				Cost		run_cost;
 				double		nbytes = relation_byte_size(path->rows,
 														path->pathtarget->width);
 				long		work_mem_bytes = work_mem * 1024L;
 
+				cost_set_member_mul(&run_cost, cpu_operator_cost, path->rows);
 				if (nbytes > work_mem_bytes)
 				{
 					/* It will spill, so account for re-read cost */
 					double		npages = ceil(nbytes / BLCKSZ);
 
-					run_cost += seq_page_cost * npages;
+					cost_add_member_mul(&run_cost, seq_page_cost, npages);
 				}
-				*rescan_startup_cost = 0;
+				cost_zero(rescan_startup_cost);
 				*rescan_total_cost = run_cost;
 			}
 			break;
@@ -3822,8 +3845,8 @@ cost_qual_eval(QualCost *cost, List *quals, PlannerInfo *root)
 	ListCell   *l;
 
 	context.root = root;
-	context.total.startup = 0;
-	context.total.per_tuple = 0;
+	cost_zero(&context.total.startup);
+	cost_zero(&context.total.per_tuple);
 
 	/* We don't charge any cost for the implicit ANDing at top level ... */
 
@@ -3847,8 +3870,8 @@ cost_qual_eval_node(QualCost *cost, Node *qual, PlannerInfo *root)
 	cost_qual_eval_context context;
 
 	context.root = root;
-	context.total.startup = 0;
-	context.total.per_tuple = 0;
+	cost_zero(&context.total.startup);
+	cost_zero(&context.total.per_tuple);
 
 	cost_qual_eval_walker(qual, &context);
 
@@ -3871,13 +3894,13 @@ cost_qual_eval_walker(Node *node, cost_qual_eval_context *context)
 	{
 		RestrictInfo *rinfo = (RestrictInfo *) node;
 
-		if (rinfo->eval_cost.startup < 0)
+		if (cost_asscalar(&rinfo->eval_cost.startup) < 0)
 		{
 			cost_qual_eval_context locContext;
 
 			locContext.root = context->root;
-			locContext.total.startup = 0;
-			locContext.total.per_tuple = 0;
+			cost_zero(&locContext.total.startup);
+			cost_zero(&locContext.total.per_tuple);
 
 			/*
 			 * For an OR clause, recurse into the marked-up tree so that we
@@ -3895,13 +3918,13 @@ cost_qual_eval_walker(Node *node, cost_qual_eval_context *context)
 			if (rinfo->pseudoconstant)
 			{
 				/* count one execution during startup */
-				locContext.total.startup += locContext.total.per_tuple;
-				locContext.total.per_tuple = 0;
+				cost_add(&locContext.total.startup, &locContext.total.per_tuple);
+				cost_zero(&locContext.total.per_tuple);
 			}
 			rinfo->eval_cost = locContext.total;
 		}
-		context->total.startup += rinfo->eval_cost.startup;
-		context->total.per_tuple += rinfo->eval_cost.per_tuple;
+		cost_add(&context->total.startup, &rinfo->eval_cost.startup);
+		cost_add(&context->total.per_tuple, &rinfo->eval_cost.per_tuple);
 		/* do NOT recurse into children */
 		return false;
 	}
@@ -3953,12 +3976,13 @@ cost_qual_eval_walker(Node *node, cost_qual_eval_context *context)
 		QualCost	sacosts;
 
 		set_sa_opfuncid(saop);
-		sacosts.startup = sacosts.per_tuple = 0;
+		cost_zero(&sacosts.startup);
+		cost_zero(&sacosts.per_tuple);
 		add_function_cost(context->root, saop->opfuncid, NULL,
 						  &sacosts);
-		context->total.startup += sacosts.startup;
-		context->total.per_tuple += sacosts.per_tuple *
-			estimate_array_length(arraynode) * 0.5;
+		cost_add(&context->total.startup, &sacosts.startup);
+		cost_add_mul(&context->total.per_tuple, &sacosts.per_tuple,
+			estimate_array_length(arraynode) * 0.5);
 	}
 	else if (IsA(node, Aggref) ||
 			 IsA(node, WindowFunc))
@@ -3999,10 +4023,10 @@ cost_qual_eval_walker(Node *node, cost_qual_eval_context *context)
 
 		cost_qual_eval_node(&perelemcost, (Node *) acoerce->elemexpr,
 							context->root);
-		context->total.startup += perelemcost.startup;
-		if (perelemcost.per_tuple > 0)
-			context->total.per_tuple += perelemcost.per_tuple *
-				estimate_array_length((Node *) acoerce->arg);
+		cost_add(&context->total.startup, &perelemcost.startup);
+		if (cost_asscalar(&perelemcost.per_tuple) > 0)
+			cost_add_mul(&context->total.per_tuple, &perelemcost.per_tuple,
+				estimate_array_length((Node *) acoerce->arg));
 	}
 	else if (IsA(node, RowCompareExpr))
 	{
@@ -4025,12 +4049,12 @@ cost_qual_eval_walker(Node *node, cost_qual_eval_context *context)
 			 IsA(node, NextValueExpr))
 	{
 		/* Treat all these as having cost 1 */
-		context->total.per_tuple += cpu_operator_cost;
+		cost_add_member(&context->total.per_tuple, cpu_operator_cost);
 	}
 	else if (IsA(node, CurrentOfExpr))
 	{
 		/* Report high cost to prevent selection of anything but TID scan */
-		context->total.startup += disable_cost;
+		cost_add_member(&context->total.startup, disable_cost);
 	}
 	else if (IsA(node, SubLink))
 	{
@@ -4047,8 +4071,8 @@ cost_qual_eval_walker(Node *node, cost_qual_eval_context *context)
 		 */
 		SubPlan    *subplan = (SubPlan *) node;
 
-		context->total.startup += subplan->startup_cost;
-		context->total.per_tuple += subplan->per_call_cost;
+		cost_add(&context->total.startup, &subplan->startup_cost);
+		cost_add(&context->total.per_tuple, &subplan->per_call_cost);
 
 		/*
 		 * We don't want to recurse into the testexpr, because it was already
@@ -4111,8 +4135,8 @@ get_restriction_qual_cost(PlannerInfo *root, RelOptInfo *baserel,
 		/* Include costs of pushed-down clauses */
 		cost_qual_eval(qpqual_cost, param_info->ppi_clauses, root);
 
-		qpqual_cost->startup += baserel->baserestrictcost.startup;
-		qpqual_cost->per_tuple += baserel->baserestrictcost.per_tuple;
+		cost_add(&qpqual_cost->startup, &baserel->baserestrictcost.startup);
+		cost_add(&qpqual_cost->per_tuple, &baserel->baserestrictcost.per_tuple);
 	}
 	else
 		*qpqual_cost = baserel->baserestrictcost;
@@ -5223,8 +5247,8 @@ set_rel_width(PlannerInfo *root, RelOptInfo *rel)
 	ListCell   *lc;
 
 	/* Vars are assumed to have cost zero, but other exprs do not */
-	rel->reltarget->cost.startup = 0;
-	rel->reltarget->cost.per_tuple = 0;
+	cost_zero(&rel->reltarget->cost.startup);
+	cost_zero(&rel->reltarget->cost.per_tuple);
 
 	foreach(lc, rel->reltarget->exprs)
 	{
@@ -5301,8 +5325,8 @@ set_rel_width(PlannerInfo *root, RelOptInfo *rel)
 
 			tuple_width += phinfo->ph_width;
 			cost_qual_eval_node(&cost, (Node *) phv->phexpr, root);
-			rel->reltarget->cost.startup += cost.startup;
-			rel->reltarget->cost.per_tuple += cost.per_tuple;
+			cost_add(&rel->reltarget->cost.startup, &cost.startup);
+			cost_add(&rel->reltarget->cost.per_tuple, &cost.per_tuple);
 		}
 		else
 		{
@@ -5319,8 +5343,8 @@ set_rel_width(PlannerInfo *root, RelOptInfo *rel)
 			tuple_width += item_width;
 			/* Not entirely clear if we need to account for cost, but do so */
 			cost_qual_eval_node(&cost, node, root);
-			rel->reltarget->cost.startup += cost.startup;
-			rel->reltarget->cost.per_tuple += cost.per_tuple;
+			cost_add(&rel->reltarget->cost.startup, &cost.startup);
+			cost_add(&rel->reltarget->cost.per_tuple, &cost.per_tuple);
 		}
 	}
 
@@ -5379,8 +5403,8 @@ set_pathtarget_cost_width(PlannerInfo *root, PathTarget *target)
 	ListCell   *lc;
 
 	/* Vars are assumed to have cost zero, but other exprs do not */
-	target->cost.startup = 0;
-	target->cost.per_tuple = 0;
+	cost_zero(&target->cost.startup);
+	cost_zero(&target->cost.per_tuple);
 
 	foreach(lc, target->exprs)
 	{
@@ -5434,8 +5458,8 @@ set_pathtarget_cost_width(PlannerInfo *root, PathTarget *target)
 
 			/* Account for cost, too */
 			cost_qual_eval_node(&cost, node, root);
-			target->cost.startup += cost.startup;
-			target->cost.per_tuple += cost.per_tuple;
+			cost_add(&target->cost.startup, &cost.startup);
+			cost_add(&target->cost.per_tuple, &cost.per_tuple);
 		}
 	}
 
@@ -5603,3 +5627,178 @@ compute_bitmap_pages(PlannerInfo *root, RelOptInfo *baserel, Path *bitmapqual,
 
 	return pages_fetched;
 }
+
+void cost_zero(Cost *to)
+{
+	memset(to, 0, sizeof(*to));
+}
+
+void cost_set_sum2(Cost *to, const Cost *from1, const Cost *from2)
+{
+        to->cpu_index_tuple_cost = from1->cpu_index_tuple_cost + from2 ->cpu_index_tuple_cost;
+        to->cpu_operator_cost = from1->cpu_operator_cost + from2->cpu_operator_cost;
+        to->cpu_tuple_cost = from1->cpu_tuple_cost  + from2->cpu_tuple_cost;
+        to->parallel_setup_cost = from1->parallel_setup_cost  + from2->parallel_setup_cost;
+        to->parallel_tuple_cost = from1->parallel_tuple_cost  + from2->parallel_tuple_cost;
+        to->random_page_cost = from1->random_page_cost  + from2->random_page_cost;
+        to->seq_page_cost = from1->seq_page_cost  + from2->seq_page_cost;
+        to->disable_cost = from1->disable_cost  + from2->disable_cost;
+}
+
+void cost_set_sum3(Cost *to, const Cost *from1, const Cost *from2, const Cost *from3)
+{
+        to->cpu_index_tuple_cost =
+		from1->cpu_index_tuple_cost +
+		from2->cpu_index_tuple_cost +
+		from3->cpu_index_tuple_cost;
+        to->cpu_operator_cost =
+		from1->cpu_operator_cost +
+		from2->cpu_operator_cost +
+		from3->cpu_operator_cost;
+        to->cpu_tuple_cost =
+		from1->cpu_tuple_cost +
+		from2->cpu_tuple_cost +
+		from3->cpu_tuple_cost;
+        to->parallel_setup_cost =
+		from1->parallel_setup_cost +
+		from2->parallel_setup_cost +
+		from3->parallel_setup_cost;
+        to->parallel_tuple_cost =
+		from1->parallel_tuple_cost +
+		from2->parallel_tuple_cost +
+		from3->parallel_tuple_cost;
+        to->random_page_cost =
+		from1->random_page_cost +
+		from2->random_page_cost +
+		from3->random_page_cost;
+        to->seq_page_cost =
+		from1->seq_page_cost +
+		from2->seq_page_cost +
+		from3->seq_page_cost;
+        to->disable_cost =
+		from1->disable_cost +
+		from2->disable_cost +
+		from3->disable_cost;
+}
+
+void cost_set_diff(Cost *to, const Cost *from1, const Cost *from2)
+{
+        to->cpu_index_tuple_cost = from1->cpu_index_tuple_cost - from2 ->cpu_index_tuple_cost;
+        to->cpu_operator_cost = from1->cpu_operator_cost - from2->cpu_operator_cost;
+        to->cpu_tuple_cost = from1->cpu_tuple_cost  - from2->cpu_tuple_cost;
+        to->parallel_setup_cost = from1->parallel_setup_cost  - from2->parallel_setup_cost;
+        to->parallel_tuple_cost = from1->parallel_tuple_cost  - from2->parallel_tuple_cost;
+        to->random_page_cost = from1->random_page_cost  - from2->random_page_cost;
+        to->seq_page_cost = from1->seq_page_cost  - from2->seq_page_cost;
+        to->disable_cost = from1->disable_cost  - from2->disable_cost;
+}
+
+void cost_add(Cost *to, const Cost *from1)
+{
+        /* Hack to allow calling append_nonpartial_cost... */
+        if (!from1)
+		return;
+
+        to->cpu_index_tuple_cost += from1->cpu_index_tuple_cost;
+        to->cpu_operator_cost += from1->cpu_operator_cost;
+        to->cpu_tuple_cost += from1->cpu_tuple_cost;
+        to->parallel_setup_cost += from1->parallel_setup_cost;
+        to->parallel_tuple_cost += from1->parallel_tuple_cost;
+        to->random_page_cost += from1->random_page_cost;
+        to->seq_page_cost += from1->seq_page_cost;
+        to->disable_cost += from1->disable_cost;
+}
+
+void cost_add2(Cost *to, const Cost *from1, const Cost *from2)
+{
+        to->cpu_index_tuple_cost +=
+		from1->cpu_index_tuple_cost +
+		from2->cpu_index_tuple_cost;
+        to->cpu_operator_cost +=
+		from1->cpu_operator_cost +
+		from2->cpu_operator_cost;
+        to->cpu_tuple_cost +=
+		from1->cpu_tuple_cost +
+		from2->cpu_tuple_cost;
+        to->parallel_setup_cost +=
+		from1->parallel_setup_cost +
+		from2->parallel_setup_cost;
+        to->parallel_tuple_cost +=
+		from1->parallel_tuple_cost +
+		from2->parallel_tuple_cost;
+        to->random_page_cost +=
+		from1->random_page_cost +
+		from2->random_page_cost;
+        to->seq_page_cost +=
+		from1->seq_page_cost +
+		from2->seq_page_cost;
+        to->disable_cost +=
+		from1->disable_cost +
+		from2->disable_cost;
+}
+
+void cost_add_mul(Cost *to, const Cost *from1, double mul)
+{
+        to->cpu_index_tuple_cost +=
+		mul * from1->cpu_index_tuple_cost;
+        to->cpu_operator_cost +=
+		mul * from1->cpu_operator_cost;
+        to->cpu_tuple_cost +=
+		mul * from1->cpu_tuple_cost;
+        to->parallel_setup_cost +=
+		mul * from1->parallel_setup_cost;
+        to->parallel_tuple_cost +=
+		mul * from1->parallel_tuple_cost;
+        to->random_page_cost +=
+		mul * from1->random_page_cost;
+        to->seq_page_cost +=
+		mul * from1->seq_page_cost;
+        to->disable_cost +=
+		mul * from1->disable_cost;
+}
+
+void cost_sub(Cost *to, const Cost *from1)
+{
+        to->cpu_index_tuple_cost -= from1->cpu_index_tuple_cost;
+        to->cpu_operator_cost -= from1->cpu_operator_cost;
+        to->cpu_tuple_cost -= from1->cpu_tuple_cost;
+        to->parallel_setup_cost -= from1->parallel_setup_cost;
+        to->parallel_tuple_cost -= from1->parallel_tuple_cost;
+        to->random_page_cost -= from1->random_page_cost;
+        to->seq_page_cost -= from1->seq_page_cost;
+        to->disable_cost -= from1->disable_cost;
+}
+
+void cost_mul_scalar(Cost *to, double mul)
+{
+        to->cpu_index_tuple_cost *= mul;
+        to->cpu_operator_cost *= mul;
+        to->cpu_tuple_cost *= mul;
+        to->parallel_setup_cost *= mul;
+        to->parallel_tuple_cost *= mul;
+        to->random_page_cost *= mul;
+        to->seq_page_cost *= mul;
+        to->disable_cost *= mul;
+}
+
+double cost_asscalar(const Cost *to)
+{
+	return to->cpu_index_tuple_cost 
+		+ to->cpu_operator_cost 
+		+ to->cpu_tuple_cost 
+		+ to->parallel_setup_cost 
+		+ to->parallel_tuple_cost 
+		+ to->random_page_cost 
+		+ to->seq_page_cost 
+		+ to->disable_cost;
+}
+
+bool cost_isgt(const Cost *to, const Cost *than)
+{
+	return cost_asscalar(to) > cost_asscalar(than);
+}
+
+bool cost_islt(const Cost *to, const Cost *than)
+{
+	return cost_asscalar(to) < cost_asscalar(than);
+}
diff --git a/src/backend/optimizer/path/indxpath.c b/src/backend/optimizer/path/indxpath.c
index 37b257c..1277dec 100644
--- a/src/backend/optimizer/path/indxpath.c
+++ b/src/backend/optimizer/path/indxpath.c
@@ -1372,7 +1372,7 @@ choose_bitmap_and(PlannerInfo *root, RelOptInfo *rel, List *paths)
 	PathClauseUsage *pathinfo;
 	List	   *clauselist;
 	List	   *bestpaths = NIL;
-	Cost		bestcost = 0;
+	Cost		bestcost = {0};
 	int			i,
 				j;
 	ListCell   *l;
@@ -1469,7 +1469,7 @@ choose_bitmap_and(PlannerInfo *root, RelOptInfo *rel, List *paths)
 
 			cost_bitmap_tree_node(pathinfo->path, &ncost, &nselec);
 			cost_bitmap_tree_node(pathinfoarray[i]->path, &ocost, &oselec);
-			if (ncost < ocost)
+			if (cost_islt(&ncost, &ocost))
 				pathinfoarray[i] = pathinfo;
 		}
 		else
@@ -1537,7 +1537,7 @@ choose_bitmap_and(PlannerInfo *root, RelOptInfo *rel, List *paths)
 			/* tentatively add new path to paths, so we can estimate cost */
 			paths = lappend(paths, pathinfo->path);
 			newcost = bitmap_and_cost_est(root, rel, paths);
-			if (newcost < costsofar)
+			if (cost_islt(&newcost, &costsofar))
 			{
 				/* keep new path in paths, update subsidiary variables */
 				costsofar = newcost;
@@ -1554,7 +1554,7 @@ choose_bitmap_and(PlannerInfo *root, RelOptInfo *rel, List *paths)
 		}
 
 		/* Keep the cheapest AND-group (or singleton) */
-		if (i == 0 || costsofar < bestcost)
+		if (i == 0 || cost_islt(&costsofar, &bestcost))
 		{
 			bestpaths = paths;
 			bestcost = costsofar;
@@ -1586,9 +1586,9 @@ path_usage_comparator(const void *a, const void *b)
 	/*
 	 * If costs are the same, sort by selectivity.
 	 */
-	if (acost < bcost)
+	if (cost_islt(&acost, &bcost))
 		return -1;
-	if (acost > bcost)
+	if (cost_isgt(&acost, &bcost))
 		return 1;
 
 	if (aselec < bselec)
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index aee81bd..561151d 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -3211,7 +3211,7 @@ create_bitmap_subplan(PlannerInfo *root, Path *bitmapqual,
 											  iscan->indexqual,
 											  iscan->indexqualorig);
 		/* and set its cost/width fields appropriately */
-		plan->startup_cost = 0.0;
+		cost_zero(&plan->startup_cost);
 		plan->total_cost = ipath->indextotalcost;
 		plan->plan_rows =
 			clamp_row_est(ipath->indexselectivity * ipath->path.parent->tuples);
@@ -4197,7 +4197,7 @@ create_mergejoin_plan(PlannerInfo *root,
 		 * sync with final_cost_mergejoin.)
 		 */
 		copy_plan_costsize(matplan, inner_plan);
-		matplan->total_cost += cpu_operator_cost * matplan->plan_rows;
+		cost_add_member_mul(&matplan->total_cost, cpu_operator_cost, matplan->plan_rows);
 
 		inner_plan = matplan;
 	}
@@ -4994,7 +4994,7 @@ order_qual_clauses(PlannerInfo *root, List *clauses)
 			 * security level, which is not so great, but we can alleviate
 			 * that risk by applying the cost limit cutoff.
 			 */
-			if (rinfo->leakproof && items[i].cost < 10 * cpu_operator_cost)
+			if (rinfo->leakproof && cost_asscalar(&items[i].cost) < 10 * cpu_operator_cost)
 				items[i].security_level = 0;
 			else
 				items[i].security_level = rinfo->security_level;
@@ -5021,7 +5021,7 @@ order_qual_clauses(PlannerInfo *root, List *clauses)
 
 			if (newitem.security_level > olditem->security_level ||
 				(newitem.security_level == olditem->security_level &&
-				 newitem.cost >= olditem->cost))
+				 !cost_islt(&newitem.cost, &olditem->cost)))
 				break;
 			items[j] = *olditem;
 		}
@@ -5083,12 +5083,13 @@ label_sort_with_costsize(PlannerInfo *root, Sort *plan, double limit_tuples)
 {
 	Plan	   *lefttree = plan->plan.lefttree;
 	Path		sort_path;		/* dummy for result of cost_sort */
+	Cost		zero = {0};
 
 	cost_sort(&sort_path, root, NIL,
-			  lefttree->total_cost,
+			  &lefttree->total_cost,
 			  lefttree->plan_rows,
 			  lefttree->plan_width,
-			  0.0,
+			  &zero,
 			  work_mem,
 			  limit_tuples);
 	plan->plan.startup_cost = sort_path.startup_cost;
diff --git a/src/backend/optimizer/plan/planagg.c b/src/backend/optimizer/plan/planagg.c
index 974f620..0fd3897 100644
--- a/src/backend/optimizer/plan/planagg.c
+++ b/src/backend/optimizer/plan/planagg.c
@@ -314,7 +314,7 @@ find_minmax_aggs_walker(Node *node, List **context)
 		mminfo->target = curTarget->expr;
 		mminfo->subroot = NULL; /* don't compute path yet */
 		mminfo->path = NULL;
-		mminfo->pathcost = 0;
+		cost_zero(&mminfo->pathcost);
 		mminfo->param = NULL;
 
 		*context = lappend(*context, mminfo);
@@ -484,8 +484,9 @@ build_minmax_path(PlannerInfo *root, MinMaxAggInfo *mminfo,
 	 * Note: cost calculation here should match
 	 * compare_fractional_path_costs().
 	 */
-	path_cost = sorted_path->startup_cost +
-		path_fraction * (sorted_path->total_cost - sorted_path->startup_cost);
+	cost_set_diff(&path_cost, &sorted_path->total_cost, &sorted_path->startup_cost);
+	cost_mul_scalar(&path_cost, path_fraction);
+	cost_add(&path_cost, &sorted_path->startup_cost);
 
 	/* Save state for further processing */
 	mminfo->subroot = subroot;
